import { MessageCenter } from "utils-lib-js";
export type IQueues<F = Function[]> = {
    queue: F;
    id?: string;
    result?: unknown[];
};
export type IQueueList = IQueues<Function>[];
export type IQueuesParams = Function[];
export type IQueueTemp = {
    [key: string]: IQueues;
};
export type IState = "idle" | "pending" | "fulfilled" | "rejected";
export type ITaskQueueProps = {
    maxLen: number;
};
export declare class TaskQueue extends MessageCenter {
    props: ITaskQueueProps;
    queues: IQueueList;
    queueTemp: IQueueTemp;
    state: IState;
    defaultKey: string;
    defaultLen: number;
    constructor(props: ITaskQueueProps);
    push: (queue: IQueuesParams, id?: string) => Promise<void>;
    run: () => Promise<void>;
    private finish;
    private formatQueue;
    isPromise: (fn: any) => boolean;
    voidObj: () => any;
    unshift: (length?: number) => IQueues<Function>[];
    clearQueue: () => void;
    private checkQueue;
}
export default TaskQueue;
